searchData={"items":[{"type":"extras","title":"Home","doc":"---\n\n# observer_cli\n\n[![Build Status](https://github.com/zhongwencool/observer_cli/workflows/ci/badge.svg)](https://github.com/zhongwencool/observer_cli/actions)\n[![GitHub tag](https://img.shields.io/github/tag/zhongwencool/observer_cli.svg)](https://github.com/zhongwencool/observer_cli)\n[![MIT License](https://img.shields.io/hexpm/l/observer_cli.svg)](https://hex.pm/packages/observer_cli)\n[![Hex.pm Version](https://img.shields.io/hexpm/v/observer_cli.svg)](https://hex.pm/packages/observer_cli)\n[![Hex.pm Downloads](https://img.shields.io/hexpm/dt/observer_cli.svg)](https://hex.pm/packages/observer_cli)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/oberver_cli/)\n\nObserver CLI is a library to be dropped into any beam nodes, to be used to assist DevOps  people diagnose problems in production nodes. Based on [recon](https://github.com/ferd/recon).\n\n   \n\n- Provide a high-performance tool usable both in development and production settings.\n- Focus on important and detailed information about real-time running system.\n- Keep minimal consumption.\n\n---","ref":"readme.html"},{"type":"extras","title":"Installation - Home","doc":"<!-- tabs-open -->","ref":"readme.html#installation"},{"type":"extras","title":"Erlang - Home","doc":"```erlang\n%% rebar.config\n{deps, [observer_cli]}\n%% erlang.mk\ndep_observer_cli = hex 1.8.3\n```","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - Home","doc":"```elixir\n# mix.exs\n   def deps do\n     [{:observer_cli, \"~> 1.8\"}]\n   end\n```\n<!-- tabs-close -->","ref":"readme.html#elixir"},{"type":"extras","title":"How-To - Home","doc":"","ref":"readme.html#how-to"},{"type":"extras","title":"Try in local shell. - Home","doc":"<!-- tabs-open -->","ref":"readme.html#try-in-local-shell"},{"type":"extras","title":"Erlang - Home","doc":"```erlang\n%% rebar3 project\nrebar3 shell\n1> observer_cli:start().\n```","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - Home","doc":"```elixir\n%% mix project\niex -S mix\niex(1)> :observer_cli.start\n```\n<!-- tabs-close -->","ref":"readme.html#elixir"},{"type":"extras","title":"Monitor remote node - Home","doc":"<!-- tabs-open -->","ref":"readme.html#monitor-remote-node"},{"type":"extras","title":"Erlang - Home","doc":"```erlang\n%% rebar3 project\nrebar3 shell --name 'observer_cli@127.0.0.1'\n1> observer_cli:start('target@host', 'magic_cookie').\n```","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - Home","doc":"```elixir\n%% mix project\niex --name \"observer_cli@127.0.0.1\" -S mix\niex(1)> :observer_cli.start(:'target@host', :'magic_cookie')\n```\n<!-- tabs-close -->\n\n> #### exclamation {: .info}\n> **ensure observer_cli application been loaded on target node.**","ref":"readme.html#elixir"},{"type":"extras","title":"Escriptize - Home","doc":"1. cd path/to/observer_cli/\n2. `rebar3 escriptize` to generate an escript executable containing the project's and its dependencies' BEAM files.\n   Place script(`_build/default/bin/observer_cli`) anywhere in your path and use `observer_cli` command.\n3. `observer_cli TARGETNODE [TARGETCOOKIE REFRESHMS]` to monitor remote node.","ref":"readme.html#escriptize"},{"type":"extras","title":"Features - Home","doc":"","ref":"readme.html#features"},{"type":"extras","title":"Home Panel - Home","doc":"![Home](https://user-images.githubusercontent.com/3116225/96714573-ede2f280-13d4-11eb-999c-f2aedb0d6ab1.jpg)\n\nThe Home panel provides a comprehensive overview of your Erlang node:\n\n[`erlang:system_info/1`](http://erlang.org/doc/man/erlang.html#system_info-1) returns specified information about the current system by below item. When the ratio is greater than 85%, it becomes red.\n\n| Metric             | Source/Limit              |\n|--------------------|---------------------------|\n| Proc Count         | process_count/process_limit |\n| Port Count         | port_count/port_limit   |\n| Atom Count         | atom_count/atom_limit     |\n\n* **process_limit**: `erl +P Number` sets the maximum number of simultaneously existing processes for this system if a Number is passed as value. Valid range for Number is [1024-134217727]. The default value is 262144.\n* **port_limit**: `erl +Q Number` sets the maximum number of simultaneously existing ports for this system if a Number is passed as value. Valid range for Number is [1024-134217727]. The default value used is normally 65536. However, if the runtime system is able to determine maximum amount of file descriptors that it is allowed to open and this value is larger than 65536, the chosen value will increased to a value larger or equal to the maximum amount of file descriptors that can be opened.\n* **atom_limit**: `erl +t size` sets the maximum number of atoms the virtual machine can handle. Defaults to 1,048,576.\n\n[`PS`](https://man7.org/linux/man-pages/man1/ps.1.html) report a snapshot of the beam process.\n\n| Command/Flag | Description                                                                                                                                                                                             |\n|--------------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n| ps -o pcpu   | cpu utilization of the process in \"##.#\" format. Currently, it is the CPU time used divided by the time the process has been running (cputime/realtime ratio), expressed as a percentage. It will not add up to 100% unless you are lucky. |\n| ps -o pmem   | ratio of the process's resident set size to the physical memory on the machine, expressed as a percentage.                                                                                             |\n\n[`erlang:memory/0`](http://erlang.org/doc/man/erlang.html#memory-0) Returns a list with information about memory dynamically allocated by the Erlang emulator.\n\n[`erlang:statistics/1`](http://erlang.org/doc/man/erlang.html#statistics-1)\n\n| Statistic                     | Description                                                                                                                                                                                |\n|-------------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n| active task                   | returns the same as `statistics(active_tasks_all)` with the exception that no information about the dirty IO run queue and its associated schedulers is part of the result. That is, only tasks that are expected to be CPU bound are part of the result. |\n| context switches              | returns the total number of context switches since the system started.                                                                                                                      |\n| reductions(total/sinceLastCall) | total reductions/reductions since last call.                                                                                                                                               |\n| io                            | The total number of bytes received/send through ports and the receive/send bytes through ports of growth during the refresh interval.                                                       |\n| garbage_collection            | `erlang:statistics(garbage_collection)` which returns the total value and the `{Number_of_GCs, Words_Reclaimed}` of growth during the refresh interval.                                       |\n| run_queue                     | The total length of all normal run-queues. That is, the number of processes and ports that are ready to run on all available normal run-queues. Dirty run queues are not part of the result. |\n\nIncrements are values that are mostly useful when compared to a previous\none to have an idea what they're doing, because otherwise they'd never\nstop increasing: bytes in and out of the node, number of garbage collector\nruns, words of memory that were garbage collected, and the global reductions\ncount for the node.\n\nScheduler utilization by [`erlang:statistics(scheduler_wall_time)`](http://erlang.org/doc/man/erlang.html#statistics_scheduler_wall_time):\n\n* Total scheduler utilization will equal 1.0 when all schedulers have been active all the time between the two refresh intervals.\n* The result being that there is a decent chunk of CPU usage that would be mostly free for scheduling actual Erlang work (assuming the schedulers are busy waiting more than trying to select tasks to run), but is being reported as busy by the OS.\n* The scheduler usage may show a higher rate (1.0) than what the OS will report. Schedulers waiting for OS resources are considered utilized as they cannot handle more work. If the OS itself is holding up on non-CPU tasks it is still possible for Erlang’s schedulers not to be able to do more work and report a full ratio.","ref":"readme.html#home-panel"},{"type":"extras","title":"Process - Home","doc":"When looking for high memory usage, for example it's interesting to be able to list all of a node's processes and find the top N consumers. Enter `m` then press `Enter` will use the `recon:proc_count(memory, N)` function, we can get:\n\n![Top](https://user-images.githubusercontent.com/3116225/96717499-25539e00-13d9-11eb-85af-fdde633da098.jpg)\n\n[`recon:proc_count/2`](http://ferd.github.io/recon/recon.html#proc_count-2) and [`recon:proc_window/3`](http://ferd.github.io/recon/recon.html#proc_window-3) are to be used when you require information about processes in a larger sense: biggest consumers of given process `memory`, `reductions`, `binary`, `total_heap_size`, `message_queue_len`, either absolutely or over a sliding time window, respectively.\n\nMore detail about sliding time windows see [`recon:proc_window/3`](http://ferd.github.io/recon/recon.html#proc_window-3)\n\nWhen an abnormal process is found, enter the suspected process sequence(Integer) then press `Enter` will use [`erlang:process_info/2`](http://erlang.org/doc/man/erlang.html#process_info-2) to show a lot of information available (which is safe to use in production) about processes.\n\n![Process](https://user-images.githubusercontent.com/3116225/39091219-66ba0398-4622-11e8-81b1-f489251f111a.jpg)\n\n* **registered_name**: if the process has a name (as registered with `erlang:register/2`), it is given here.\n* **trap_exit**: set `trap_exit` to true, exit signals arriving to a process are converted to `{EXIT,From,Reason}` messages, which can be received as ordinary messages. If `trap_exit` is set to false, the process exits if it receives an exit signal other than normal and the exit signal is propagated to its linked processes. Application processes are normally not to trap exits.\n* **group_leader**: the group leader of a process defines where IO (files, output of `io:format/1-3`) goes.\n* **initial_call**: is the initial function call with which the process was spawned.\n* **links**: is a list of process identifiers and port identifiers, with processes or ports to which the process has a link.\n* **monitored_by**: A list of process identifiers monitoring the process (with `monitor/2`).\n* **monitors**: A list of monitors (started by `monitor/2`) that are active for the process. For a local process monitor or a remote process monitor by a process identifier.\n* **status**: the nature of the process as seen by the scheduler. The possible values are:\n    * `exiting` the process is done, but not fully cleared yet;\n    * `waiting` the process is waiting in a `receive ... end`;\n    * `running` self-descriptive;\n    * `runnable` ready to run, but not scheduled yet because another process is running;\n    * `garbage_collecting` self-descriptive;\n    * `suspended` whenever it is suspended by a BIF, or as a back-pressure mechanism because a socket or port buffer is full. The process only becomes runnable again once the port is no longer busy\n* **reductions**: The VM does scheduling based on reductions, an arbitrary unit of work that allows rather portable implementations of scheduling (time-based scheduling is usually hard to make work efficiently on as many OSes as Erlang runs on). The higher the reductions, the more work, in terms of CPU and function calls, a process is doing.\n* **memory**: Includes call stack, heap, and internal structures. `total_heap_size`, `min_bin_vheap_size`, `min_heap_size`, `fullsweep_after`, `heap_size`.\n* **messages**: A list of the messages to the process, which have not yet been processed, it is truncated when the term is too big.\n* **dictionary**: Dictionary is the process dictionary, it is truncated when the term is too big.\n* **current stack**: The current call stack back-trace (**stacktrace**) of the process. The stack has the same format as returned by `erlang:get_stacktrace/0`. The depth of the stacktrace is truncated according to `backtrace_depth` system flag setting.\n* **state**: Using [`sys:get_state(Pid, 2500)`](http://erlang.org/doc/man/sys.html#get_state-2) Gets the state of the process.","ref":"readme.html#process"},{"type":"extras","title":"Network - Home","doc":"![Network](https://user-images.githubusercontent.com/3116225/96717492-2389da80-13d9-11eb-9795-0f77ee441329.jpg)\n\n* **Byte input/output**: The byte of growth input/output during the refresh interval.\n* **Total input/output**: [`erlang:statistics(io)`](http://erlang.org/doc/man/erlang.html#statistics-1) returns `Input`, which is the total number of bytes received through ports, and `Output`, which is the total number of bytes output to ports.\n\nFetches a given attribute from all inet ports (`TCP, UDP, SCTP`) and returns the biggest Num consumers by [`recon:inet_count/2`](http://ferd.github.io/recon/recon.html#inet_count-2) and [`recon:inet_windows/3`](http://ferd.github.io/recon/recon.html#inet_window-3). Attribute name refer to [`inet:getstat/1`](http://erlang.org/doc/man/inet.html#getstat-1).\n\n* `recv_oct`: Number of bytes received by the socket.\n* `recv_cnt`: Number of packets received by the socket.\n* `send_cnt`: Number of packets sent from the socket.\n* `send_oct`: Number of bytes sent from the socket.\n* `cnt`: `recv_cnt` + `send_cnt`.\n* `oct`: `recv_oct` + `send_oct`.\n\nWhen find out who is slowly but surely eating up all your bandwidth, enter the suspected port sequence(Integer) then press `Enter` will use [`recon:port_info/2`](http://ferd.github.io/recon/recon.html#port_info-2) to show a lot of information available about port.\n\n![Port](https://user-images.githubusercontent.com/3116225/39091218-6687caf4-4622-11e8-86c7-190c2106d41e.jpg)\n\n* **id**: internal index of a port. Of no particular use except to differentiate ports.\n* **name**: type of the port — with names such as `\"tcp_inet\"`, `\"udp_inet\"`, or `\"efile\"`.\n* **os_pid**: If the port is not an inet socket, but rather represents an external process or program, this value contains the os pid related to the said external program.\n* **connected**: Each port has a controlling process in charge of it, and this process’ pid is the connected one.\n* **links**: Ports can be linked with processes, much like other processes can be. The list of linked processes is contained here. Unless the process has been owned by or manually linked to a lot of processes, this should be safe to use.\n* **monitors**: Ports that represent external programs can have these programs end up monitoring Erlang processes. These processes are listed here.\n* **IO**: `input` the number of bytes read from the port. `output` the number of bytes written to the port.\n* **queue_size**: Port programs have a specific queue, called the driver queue. This returns the size of this queue.\n* **memory**: this is the memory allocated by the runtime system for the port. This number tends to be small-ish and excludes space allocated by the port itself.\n* **sockname/peername**: [`inet:sockname/1`](http://erlang.org/doc/man/inet.html#sockname-1) a list of all local address/port number pairs for a socket.\n* **statistics**: show port statistics by [`inet:getstat/2`](http://erlang.org/doc/man/inet.html#getstat-2).\n* **options**: show port options by [`inet:getopts/2`](http://erlang.org/doc/man/inet.html#getopts-2).","ref":"readme.html#network"},{"type":"extras","title":"System - Home","doc":"![System](https://user-images.githubusercontent.com/3116225/39091213-55b9aaf8-4622-11e8-91ed-b37c04e20173.jpg)\n\n* **System Info**: [`erlang:system_info/1`](http://erlang.org/doc/man/erlang.html#system_info-1) returns various information about the allocators of the current system (emulator).\n* **Allocator Info**: [`recon_alloc:average_block_sizes(current|max)`](https://ferd.github.io/recon/recon_alloc.html#average_block_sizes-1) check all allocators in `allocator` and returns the average block sizes being used for mbcs and sbcs. This value is interesting to use because it will tell us how large most blocks are. This can be related to the VM's largest multiblock carrier size (lmbcs) and smallest multiblock carrier size (smbcs) to specify allocation strategies regarding the carrier sizes to be used.\n* **Cache Hit Rate**: [`recon_alloc:cache_hit_rates()`](https://ferd.github.io/recon/recon_alloc.html#cache_hit_rates-0) Cache can be tweaked using three VM flags: `+MMmcs`, `+MMrmcbf`, and `+MMamcbf`.","ref":"readme.html#system"},{"type":"extras","title":"ETS - Home","doc":"![Ets](https://user-images.githubusercontent.com/3116225/39091214-55eae91a-4622-11e8-95c2-bc514219b5d9.jpg)\n\nETS tables are never garbage collected, and will maintain their memory usage as long as records will be left undeleted in a table. Only removing records manually (or deleting the table) will reclaim memory.\n\nTop N list sort by memory size, all items defined in [`ets:info/2`](http://erlang.org/doc/man/ets.html#info-2)","ref":"readme.html#ets"},{"type":"extras","title":"Mnesia - Home","doc":"![Mnesia](https://user-images.githubusercontent.com/3116225/39091215-5637b4fc-4622-11e8-9639-99405318fc09.jpg)\n\nTop N list sort by memory size, all items defined in [`mnesia:table_info/2`](http://erlang.org/doc/man/mnesia.html#table_info-2)","ref":"readme.html#mnesia"},{"type":"extras","title":"Application - Home","doc":"![Application](https://user-images.githubusercontent.com/3116225/39091216-567ddab8-4622-11e8-8b32-db0f621d6b90.jpg)\n\nFind application debug information by [`application_controller:info()`](https://github.com/erlang/otp/blob/master/lib/kernel/src/application_controller.erl#L280).","ref":"readme.html#application"},{"type":"extras","title":"How to write your own plugin?","doc":"# How to write your own plugin?\n\nIf you need to customize some of your internal metrics and integrate it into observer_ci,\nyou only need to write a `observer_cli_plugin` behaviour in a few simple steps to get a nice presentation.\n\n1. Configure observer_cli，tell observer_cli how to find your plugin.\n\n```erlang\n%% module       - Specific module implements plugin behavior. It's mandatory.\n%% title        - Menu title. It's mandatory.\n%% shortcut     - Switch plugin by shortcut. It's mandatory.\n%% interval     - Refresh interval ms. It's optional. default is 1500ms.\n%% sort_column  - Sort the sheet by this index. It's optional default is 2.\n\n{plugins,\n  [\n    #{module => observer_cli_plug_behaviour_x, title => \"XPlug\",\n      interval => 1600, shortcut => \"X\", sort_column => 3},\n    #{module => observer_cli_plug_behaviour_y, title => \"YPlug\",\n      interval =>2000, shortcut => \"Y\", sort_column => 3}\n  ]\n}\n```\n\nThe main view is `HOME` by default(`observer_cli:start()`).\nIf you want to plugin view as main view, DO:`your_cli:start().`\n\n```erlang\n% your_cli.erl\nstart() -> observer_cli:start_plugin().\n```\n\n2. Write observer_cli_plugin behaviour.\n   observer_cli_plugin has 3 callbacks.\n\n2.1 attributes.\n\n```erlang\n-callback attributes(PrevState) -> {[Rows], NewState} when\n    Rows :: #{content => string()|integer()|{byte, pos_integer()},\n              width => pos_integer(), color => binary()}.\n```\n\nfor example:\n\n```erlang\nattributes(PrevState) ->\n  Attrs = [\n    [\n      #{content => \"XXX Ets Size\", width => 15},\n      #{content => 122, width => 10},\n      #{content => \"Memory Capcity\", width => 15},\n      #{content => {percent, 0.12}, width => 16},\n      #{content => \"XYZ1 Process Mem\", width => 19},\n      #{content => {byte, 1023 * 1203}, width => 19}\n    ],\n    [\n      #{content => \"YYY Ets Size\", width => 15},\n      #{content => 43, width => 10},\n      #{content => \"Disk Capcity\", width => 15},\n      #{content => {percent, 0.23}, width => 16},\n      #{content => \"XYZ2 Process Mem\", width => 19},\n      #{content => {byte, 2034 * 220}, width => 19}\n    ],\n    [\n      #{content => \"ZZZ Ets Size\", width => 15},\n      #{content => 108, width => 10},\n      #{content => \"Volume Capcity\", width => 15},\n      #{content => {percent, 0.101}, width => 16},\n      #{content => \"XYZ3 Process Mem\", width => 19},\n      #{content => {byte, 12823}, width => 19}\n    ]\n  ],\n  NewState = PrevState,\n  {Attrs, NewState}.\n```\n\n```markdown\n|Home(H)|XPlug(X)|YPlug(Y)| | 0Days 3:34:50 |\n|XXX Ets Size | 122 | Memory Capcity | 12.00% | XYZ1 Process Mem | 1.1737 MB |\n|YYY Ets Size | 43 | Disk Capcity | 23.00% | XYZ2 Process Mem | 436.9922 KB |\n|ZZZ Ets Size | 108 | Volume Capcity | 10.10% | XYZ3 Process Mem | 12.5225 KB |\n```\n\n```erlang\n-callback sheet_header() -> [SheetHeader] when\n    SheetHeader :: #{title => string(), width => pos_integer(), shortcut => string()}.\n```\n\nfor example:\n\n```erlang\nsheet_header() ->\n  [\n    #{title => \"Pid\", width => 15},\n    #{title => \"Register\", width => 20},\n    #{title => \"Memory\", width => 20, shortcut => \"S\"},\n    #{title => \"Reductions\", width => 23, shortcut => \"R\"},\n    #{title => \"Message Queue Len\", width => 23, shortcut => \"Q\"}\n  ].\n```\n\n```markdown\n|No |Pid |Register |Memory(S) |Reductions(R) |Message Queue Len(Q) |\n```\n\n```erlang\n-callback sheet_body(PrevState) -> {[SheetBody], NewState} when\n    PrevState :: any(),\n    SheetBody :: list(),\n    NewState :: any().\n\n```\n\nfor example:\n\n```erlang\nsheet_body(PrevState) ->\n  Body = [\n    begin\n      Register =\n        case erlang:process_info(Pid, registered_name) of\n          [] -> [];\n          {_, Name} -> Name\n        end,\n      [\n        Pid,\n        Register,\n        {byte, element(2, erlang:process_info(Pid, memory))},\n        element(2, erlang:process_info(Pid, reductions)),\n        element(2, erlang:process_info(Pid, message_queue_len))\n      ]\n    end\n    || Pid <- erlang:processes()\n  ],\n  NewState = PrevState,\n  {Body, NewState}.\n```\n\nSupport `{byte, 1024*10}` to ` 10.0000 KB`; `{percent, 0.12}` to `12.00%`.\n\n```markdown\n|No |Pid |Register |Memory(S) |Reductions(R) |Message Queue Len(Q) |\n|1 |<0.242.0> | | 4.5020 MB | 26544288 | 0 |\n|2 | <0.206.0> | | 1.2824 MB | 13357885 | 0 |\n|3 | <0.10.0> | erl_prim_loader | 1.0634 MB | 10046775 | 0 |\n|4 | <0.434.0> | | 419.1719 KB | 10503690 | 0 |\n|5 | <0.44.0> | application_contro | 416.6250 KB | 153598 | 0 |\n|6 | <0.50.0> | code_server | 416.4219 KB | 301045 | 0 |\n|7 | <0.9.0> | rebar_agent | 136.7031 KB | 1337603 | 0 |\n|8 | <0.207.0> | | 99.3125 KB | 9629 | 0 |\n|9 | <0.58.0> | file_server_2 | 41.3359 KB | 34303 | 0 |\n|10 | <0.209.0> | | 27.3438 KB | 31210 | 0 |\n|11 | <0.0.0> | init | 25.8516 KB | 8485 | 0 |\n|refresh: 1600ms q(quit) Positive Number(set refresh interval time ms) F/B(forward/back) Current pages is 1 |\n```\n\nSupport F/B to page up/down.\n\n[A more specific plugin](https://github.com/zhongwencool/os_stats) can collect linux system information such as kernel vsn, loadavg, disk, memory usage, cpu utilization, IO statistics.","ref":"plugin.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n- 1.8.3\n  - Fix mnesia crash by handling unknown storage types.\n  - Fix OTP 27 warning.\n  - Support ex_doc to generate documents.\n  \n- 1.8.2\n  - Fix unit of `fullsweep_after`, The value of `fullsweep_after` is a number, not bytes.\n\n- 1.8.1\n  - Show node name in system pane.\n \n- 1.8.0\n  - Support `  100.\n  - Allow to compile escript w/ inet6 based distribution.\n  - Rewrite plugin callback, rename kv_label/0 to attributes/1.\n- 1.4.1\n  - Fixed ets view memory usage wrong.\n  - mnesia view memory usage According to bytes.\n- 1.4.0\n  - Support write your own plugin.\n- 1.3.4\n  - View(ets mnesia) support page down/up; support sort by memory or size.\n  - Fixed pause crash.\n  - Make refresh interval configurable.\n- 1.3.3\n  - fixed io:format(Format,Args) Format not support iolist OTP R21\n- 1.3.2\n  - Make sure all observer_cli process exit when quit.\n  - Upgrade recon to 2.3.6\n- 1.3.1\n  - Add atom limit/count in home.\n  - Escript support short name and long name.\n  - Fixed store process not exit.\n  - [Upgrade recon to 2.3.5](https://github.com/ferd/recon/commit/e0c3614334589e375f8b1492f404e4b764fe35e7)\n- 1.3.0\n  - Rewrite Network/Process view.\n  - Support PageDown/PageUp for top n list.\n  - Escript auto load observer_cli when it's not load on target node.\n- 1.2.2\n  - fix schedule number >= 32 display wrong.\n  - improve memory(byte/kilobyte/megabyte/gigabyte) unit.\n- 1.2.1\n  - fixed autosize not work.\n  - try best to make color adjust all platform.\n- 1.2.0\n\n  - add application GUI.\n  - Rearrange GUI and optimize render.\n  - Always automatically adapt to the window size.\n\n- 1.1.0\n\n  - Support escript, `observer_cli    `\n\n- 1.0.9\n  - Upgrade rebar3 to 3.3.3 for publish hex repo.","ref":"changlog.html"},{"type":"extras","title":"LICENSE","doc":"The MIT License (MIT)\n\nCopyright (c) 2015-2025 某文 \n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}